include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "Chars.inc"

ext MonoPattern, FortPattern

pSource equ ZW0
wVram equ ZW0
wCount equ ZW0
count equ ZB0
VramH equ ZB1


cseg
CopyToVdp:
    do
        ldy #0
        do
            lda (<pSource),y | iny
            sta VdpWritePort
            jsr WaitVdp
            cpy #8
        while ne | wend
        lda <pSource | clc|adc #8 | sta <pSource
        lda <pSource+1 | adc #0 | sta <pSource+1
        dex
    while ne | wend
rts
; VdpValues:
;     defb $02, $e2
;     defb Vram_PatternName shr 10
;     defb (Vram_Color shr 6) or $7f
;     defb (Vram_PatternGenerator shr 11) or $03
;     defb Vram_SpriteAttribute shr 7
;     defb Vram_SpriteGenerator shr 11
;     defb $00
ColorSource:
defb 8, $f0 ; Ascii
defb 4, $a0 ; Logo
defb 8, $70 ; Fort
defb 0
cseg
InitVram: public InitVram
    sei
        ; ldy #$80
        ; ldx #0
        ; do
        ;     lda VdpValues,x | inx
        ;     sta VdpWritePort+1
        ;     tya | sta VdpWritePort+1
        ;     iny
        ;     cpx #8
        ; while ne | wend
            
        lda #0 | sta <VramH
        do
            lda #low Vram_PatternGenerator | sta VdpWritePort+1
            lda #$40 or high Vram_PatternGenerator | ora <VramH | sta VdpWritePort+1

            lda #low MonoPattern | sta <pSource
            lda #high MonoPattern | sta <pSource+1
            ldx #Char_Background
            jsr CopyToVdp

            lda #low FortPattern | sta <pSource
            lda #high FortPattern | sta <pSource+1
            ldx #Char_End-Char_Fort
            jsr CopyToVdp

            lda #low Vram_Color | sta VdpWritePort+1
            lda #$40 or high Vram_Color | ora <VramH | sta VdpWritePort+1
            ldx #0
            do
                lda ColorSource,x
            while ne
                sta <count
                inx
                lda ColorSource,x | inx
                do
                    sta VdpWritePort
                    jsr WaitVdp
                    dec <count
                while ne | wend
            wend
            
            lda <VramH | clc|adc #8 | sta <VramH
            cmp #8*3
        while ne | wend
    cli
    WaitVdp: public WaitVdp
rts


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        sei
            lda #low Vram_PatternName | sta VdpWritePort+1
            lda #$40 or high Vram_PatternName | sta VdpWritePort+1
            lda #Char_Space
            ldy #VramHeight
            do
                ldx #VramWidth
                do
                    sta VdpWritePort
                    jsr WaitVdp
                    dex
                while ne | wend
                dey
            while ne | wend
        cli
    pla
rts


; ptr<byte> VramAddress(byte x, byte y)
dseg
VramAddress_@Param0: public	VramAddress_@Param0
VramAddress_.x_:
    defs 1
VramAddress_@Param1: public	VramAddress_@Param1
VramAddress_.y_:
    defs 1
cseg
VramAddress_: public VramAddress_
    pha
        lda #0 | sta <wVram+1
        lda	VramAddress_.y_
        asl	a ; *2
        asl	a ; *4
        asl	a | rol <wVram+1 ; *8
        asl	a | rol <wVram+1 ; *16
        asl	a | rol <wVram+1 ; *32

        clc|adc VramAddress_.x_ | tay
        lda <wVram+1 | adc #0 | tax

        tya clc|adc #low Vram | tay
        txa adc #high Vram | tax
	pla
rts


dseg
Put_@Param0: public Put_@Param0
Put_vram:
PrintC_@Param0: public PrintC_@Param0
PrintC_vram:
WriteVram_@Param0: public WriteVram_@Param0
WriteVram_vram:
ReadVram_@Param0: public ReadVram_@Param0
ReadVram_vram:
FillVram_@Param0: public FillVram_@Param0
FillVram_vram:
    defw 0
Put_@Param1: public Put_@Param1
Put_c:
PrintC_@Param1: public PrintC_@Param1
PrintC_c:
WriteVram_@Param1: public WriteVram_@Param1
WriteVram_c:
FillVram_@Param1: public FillVram_@Param1
FillVram_b:
    defb 0


; ptr<byte> Put(word vram, byte c);
cseg
Put_: public Put_
    pha
        sei
            lda Put_vram | sta VdpWritePort+1
            lda Put_vram+1 | ora #$40 | sta VdpWritePort+1
            lda Put_c
            sta VdpWritePort
        cli
        lda Put_vram | clc|adc #1 | tay
        lda Put_vram+1 | adc #0 | tax
    pla
rts


; ptr<byte> PrintC(word vram, byte c);
cseg
PrintC_: public PrintC_
    pha
        sei
            lda PrintC_vram | sta VdpWritePort+1
            lda PrintC_vram+1 | ora #$40 | sta VdpWritePort+1
            lda PrintC_c
            sec|sbc #$20
            sta VdpWritePort
        cli
        lda PrintC_vram | clc|adc #1 | tay
        lda PrintC_vram+1 | adc #0 | tax
    pla
rts


; void WriteVram(word vram, byte b);
cseg
WriteVram_: public WriteVram_
    sei
        lda WriteVram_vram | sta VdpWritePort+1
        lda WriteVram_vram+1 | ora #$40 | sta VdpWritePort+1
        lda WriteVram_c
        sta VdpWritePort
    cli
rts


; byte ReadVram(word vram);
cseg
ReadVram_: public ReadVram_
    sei
        lda ReadVram_vram | sta VdpWritePort+1
        lda ReadVram_vram+1 | sta VdpWritePort+1
        jsr WaitVdp
        ldy VdpReadPort
    cli
rts


; void FillVram(word vram, byte b, word count);
dseg
FillVram_@Param2: public FillVram_@Param2
FillVram_count:
    defw 0
cseg
FillVram_: public FillVram_
    pha
        lda FillVram_count | sta <wCount
        lda FillVram_count+1 | sta <wCount+1
        sei
            lda FillVram_vram | sta VdpWritePort+1
            lda FillVram_vram+1 | ora #$40 | sta VdpWritePort+1
            ldx FillVram_b
            do
                stx VdpWritePort
                jsr WaitVdp
                lda <wCount | sec | sbc #1 | sta <wCount
                lda <wCount+1 | sbc #0 | sta <wCount+1
                ora <wCount
            while ne | wend
        cli
    pla
rts
