include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "Chars.inc"

ext BackgroundPattern, FortPattern
ext WaitVdp
ext CharOffset_, DotOffset_
ext FortDotOffset_, FortCharOffset_

BackgroundWidth equ VramWidth+2
BackgroundCharCount equ (Char_Background_End - Char_Background) / 2
FortCharCount equ (Char_End - Char_Fort) / 2
StageHeight equ 22

VramTop equ (Vram+VramRowSize*2) or $4000

pSource equ ZW0
pDestination equ ZW1
pNext equ ZW2
yCount equ ZB0
leftByte equ ZB0
rightByte equ ZB1

; void BackgroundToVram();
dseg
RowBuff: public RowBuff
    defs BackgroundWidth
cseg
BackgroundToVram_: public BackgroundToVram_
    pha
        lda #low Background | sta <pSource
        lda #high Background | sta <pSource+1

        lda #low VramTop | sta <pDestination
        lda #high VramTop | sta <pDestination+1

        ldy #VramHeight-2
        do
            sei
                lda <pSource | sta VdpWritePort+1
                lda <pSource+1 | sta VdpWritePort+1
                ldx #0
                do
                    jsr WaitVdp
                    lda VdpReadPort
                    sta RowBuff,x
                    inx
                    cpx #VramWidth
                while ne | wend
            cli
            lda <pSource | clc|adc #BackgroundWidth | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1
            sei
                lda <pDestination | sta VdpWritePort+1
                lda <pDestination+1 | sta VdpWritePort+1
                ldx #0
                do
                    lda RowBuff,x
                    cmp #Char_Background
                    if cs
                        clc|adc CharOffset_
                    endif
                    sta VdpWritePort
                    jsr WaitVdp
                    inx
                    cpx #VramWidth
                while ne | wend
            cli
            lda <pDestination | clc|adc #VramWidth | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1

            dey
        while ne | wend
    pla
rts


; void RollChar();
cseg
RollChar_: public RollChar_
    pha
                                        _deb:public _deb
        lda #0 | sta <pDestination+1
        lda CharOffset_
        clc|adc #Char_Background
        asl a | rol <pDestination+1 ;*2
        asl a | rol <pDestination+1 ;*4
        asl a | rol <pDestination+1 ;*8
        sei
            sta VdpWritePort+1
            lda <pDestination+1 | ora #$40 | sta VdpWritePort+1
            
            ldx #0
            do
                lda BackgroundPattern,x | inx | sta <leftByte
                lda BackgroundPattern,x | inx | sta <rightByte
                lda <leftByte
                ldy DotOffset_
                do | while ne
                    asl <rightByte | rol a
                    dey
                wend
                sta VdpWritePort
                jsr WaitVdp
                cpx #BackgroundCharCount*CharHeight*2
            while ne | wend
        cli
    pla
rts


; void SetFortChars();
cseg
SetFortChars_: public SetFortChars_
    pha
        lda #low FortPattern | sta <pSource
        lda #high FortPattern | sta <pSource+1

        lda <pSource | clc|adc #CharHeight | sta <pNext
        lda <pSource+1 | adc #0 | sta <pNext+1

        lda #0 | sta <pDestination+1
        lda FortCharOffset_ | clc|adc #Char_Fort
        asl a | rol <pDestination+1 ;*2
        asl a | rol <pDestination+1 ;*4
        asl a | rol <pDestination+1 ;*8

        sei
            sta VdpWritePort+1
            lda pDestination+1 | ora #$40 | sta VdpWritePort+1

            ldy #0
            do
                lda (pSource),y | sta <leftByte
                lda (pNext),y | sta <rightByte
                lda <leftByte
                ldx FortDotOffset_
                do | while ne
                    asl <rightByte | rol a
                    dex
                wend
                sta VdpWritePort
                jsr WaitVdp
                iny
            while ne | wend
        cli
    pla
rts


; void CopyBackground();
cseg
CopyBackground_: public CopyBackground_
    pha
        lda #low(Background+1) | sta <pSource
        lda #high(Background+1) | sta <pSource+1

        lda #low Background | sta <pDestination
        lda #high Background or $40 | sta <pDestination+1

        ldy #StageHeight
        do
            sei
                lda <pSource | sta VdpWritePort+1
                lda <pSource+1 | sta VdpWritePort+1
                ldx #0
                do
                    jsr WaitVdp
                    lda VdpReadPort
                    sta RowBuff,x | inx
                    cpx #BackgroundWidth-1
                while ne | wend
            cli
            lda <pSource | clc|adc #BackgroundWidth | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1
            sei
                lda <pDestination | sta VdpWritePort+1
                lda <pDestination+1 | sta VdpWritePort+1
                ldx #0
                do
                    lda RowBuff,x | inx
                    sta VdpWritePort
                    jsr WaitVdp
                    cpx #BackgroundWidth-1
                while ne | wend
            cli
            lda <pDestination | clc|adc #BackgroundWidth | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1
            dey
        while ne | wend
    pla
rts